/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Controller;

import LoginDb.DbHandler;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.InvocationTargetException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.beanutils.BeanUtils;
import DataEntryBean.ShgActivitiesBean;
import DataEntryBean.BasicInformationBean;


public class ShgActivitiesServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        HttpSession session = request.getSession(false);

        Connection con = null;
        CallableStatement proc = null;
        String message = "";
        String pacsId = (String) session.getAttribute("pacsId");
        String user = (String) session.getAttribute("user");


       // String ServletName = request.getParameter("handle_id");

        ShgActivitiesBean ShgActivitiesBeanObj = new ShgActivitiesBean();


        if ("Create".equalsIgnoreCase(ServletName)) {

            try {
              //  BeanUtils.populate(ShgActivitiesBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            try {
                con = DbHandler.getDBConnection();
                try {
                    proc = con.prepareCall("{ call SHG_OPERATIONS.Upsert_shg_activities(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) }");
                } catch (SQLException ex) {
                   // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during processing.");
                }
                proc.setString(1, ShgActivitiesBeanObj.getShgcode());
                proc.setString(2, ShgActivitiesBeanObj.getPresidentname());
                proc.setString(3, ShgActivitiesBeanObj.getPresidentoccupation());
                proc.setString(4, ShgActivitiesBeanObj.getPresidentmobile());
                proc.setString(5, ShgActivitiesBeanObj.getSecretaryname());
                proc.setString(6, ShgActivitiesBeanObj.getSecretaryoccupation());
                proc.setString(7, ShgActivitiesBeanObj.getSecretarymobile());
                proc.setString(8, ShgActivitiesBeanObj.getTreasurername());
                proc.setString(9, ShgActivitiesBeanObj.getTreasureroccupation());
                proc.setString(10, ShgActivitiesBeanObj.getTreasurermobile());
                proc.setString(11, ShgActivitiesBeanObj.getGrpmeeting());
                proc.setString(12, ShgActivitiesBeanObj.getResolution());
                proc.setString(13, ShgActivitiesBeanObj.getRegister());
                proc.setString(14, ShgActivitiesBeanObj.getCash());
                proc.setString(15, ShgActivitiesBeanObj.getSavings());
                proc.setString(16, ShgActivitiesBeanObj.getOther());

                proc.setString(17, ServletName);

                proc.registerOutParameter(18, java.sql.Types.VARCHAR);
                proc.setString(19, pacsId);

                proc.execute();

               // message = proc.getString(18);

            } catch (SQLException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
                System.out.println("Error occurred during processing.");
            } finally {
                try {
                    proc.close();
                } catch (SQLException e) {
                    System.out.println("Error occurred during proc close.");
                }
                try {
                    con.close();
                } catch (SQLException ex) {
                   // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during connection close.");
                }

                request.setAttribute("message", message);
                request.getRequestDispatcher("/Shg_JSP/ShgActivities.jsp").forward(request, response);

            }

        } else if ("Search".equalsIgnoreCase(ServletName)) {

            try {
              //  BeanUtils.populate(ShgActivitiesBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            Connection connection = null;
            ResultSet resultset = null;
            Statement statement = null;
            connection = DbHandler.getDBConnection();
            int SeachFound = 0;

            try {
                statement = connection.createStatement();
            } catch (SQLException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }
            try {

               // ResultSet rs = statement.executeQuery("SELECT PRESIDENT_NAME, PRESIDENT_OCCUPATION, PRESIDENT_MOBILE,SECRETARY_NAME,SECRETARY_OCCUPATION, SECRETARY_MOBILE,TREASURER_NAME, TREASURER_OCCUPATION, TREASURER_MOBILE, GRP_MEETING , RESOLUTION_BOOK , REGISTER ,CASH_BOOK,SAVINGS_BOOK,OTHERS, SHG_CODE from SHG_ACTIVITIES sa where SHG_CODE= '" + ShgActivitiesBeanObj.getShgSearch() + "' and sa.shg_id = (select to_number(shg_id) from basic_info bi where bi.shg_code = '" + ShgActivitiesBeanObj.getShgSearch() + "' and bi.pacs_id = '" +pacsId+ "') ");

                while (rs.next()) {
                    ShgActivitiesBeanObj = new ShgActivitiesBean();
                    ShgActivitiesBeanObj.setPresidentname(rs.getString("PRESIDENT_NAME"));
                    ShgActivitiesBeanObj.setPresidentoccupation(rs.getString("PRESIDENT_OCCUPATION"));
                    ShgActivitiesBeanObj.setPresidentmobile(rs.getString("PRESIDENT_MOBILE"));
                    ShgActivitiesBeanObj.setSecretaryname(rs.getString("SECRETARY_NAME"));
                    ShgActivitiesBeanObj.setSecretaryoccupation(rs.getString("SECRETARY_OCCUPATION"));
                    ShgActivitiesBeanObj.setSecretarymobile(rs.getString("SECRETARY_MOBILE"));
                    ShgActivitiesBeanObj.setTreasurername(rs.getString("TREASURER_NAME"));
                    ShgActivitiesBeanObj.setTreasureroccupation(rs.getString("TREASURER_OCCUPATION"));
                    ShgActivitiesBeanObj.setTreasurermobile(rs.getString("TREASURER_MOBILE"));
                    ShgActivitiesBeanObj.setGrpmeeting(rs.getString("GRP_MEETING"));
                    ShgActivitiesBeanObj.setResolution(rs.getString("RESOLUTION_BOOK"));
                    ShgActivitiesBeanObj.setRegister(rs.getString("REGISTER"));
                    ShgActivitiesBeanObj.setCash(rs.getString("CASH_BOOK"));
                   ShgActivitiesBeanObj.setSavings(rs.getString("SAVINGS_BOOK"));
                    ShgActivitiesBeanObj.setOther(rs.getString("OTHERS"));
                    ShgActivitiesBeanObj.setShgcode(rs.getString("SHG_CODE"));


                    SeachFound = 1;
                    request.setAttribute("displayFlag", "Y");

                }

               // statement.close();
               // connection.close();

            } catch (SQLException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    if(statement !=null)
                        statement.close();
                    if (connection != null)
                    connection.close();

            } catch (Exception e) {               
               System.out.println("Error Occurred during connection close.");
            }

            }

            if (SeachFound == 0) {
                message = "SHG Code does not exist in the system";
                request.setAttribute("message", message);
            }
            request.setAttribute("ShgActivitiesBeanObj", ShgActivitiesBeanObj);

            request.getRequestDispatcher("/Shg_JSP/ShgActivities.jsp").forward(request, response);

        }else if ("Search Code".equalsIgnoreCase(ServletName)) {
 BasicInformationBean BasicInformationBeanObj = new BasicInformationBean();
            try {
              //  BeanUtils.populate(BasicInformationBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            Connection connection = null;
            ResultSet resultset = null;
            Statement statement = null;
            connection = DbHandler.getDBConnection();
            int SeachFound = 0;

            try {
                statement = connection.createStatement();
            } catch (SQLException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }
            try {
ResultSet rs = statement.executeQuery("select NAME_OF_SHG, GRP_CATEGORY, to_char(DATE_OF_FORMATION,'DD-MON-RRRR') as DATE_OF_FORMATION , DURATION, SHG_CODE from BASIC_INFO ");

                while (rs.next()) {
                    BasicInformationBeanObj.setNameOfShg(rs.getString("NAME_OF_SHG"));
                    BasicInformationBeanObj.setGroupCategory(rs.getString("GRP_CATEGORY"));
                    BasicInformationBeanObj.setDateOfFormation(rs.getString("DATE_OF_FORMATION"));
                    BasicInformationBeanObj.setDuration(rs.getString("DURATION"));
                    BasicInformationBeanObj.setShgcode(rs.getString("SHG_CODE"));


                    SeachFound = 1;
                    request.setAttribute("displayFlag", "Y");

                }

               // statement.close();
               // connection.close();
            } catch (SQLException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    if(statement !=null)
                        statement.close();
                    if (connection != null)
                    connection.close();

            } catch (Exception e) {               
               System.out.println("Error Occurred during connection close.");
            }

            }

            if (SeachFound == 0) {
                message = "SHG Code does not exist in the system";
                request.setAttribute("message", message);
            }
            request.setAttribute("ShgActivitiesBeanObj", ShgActivitiesBeanObj);

            request.getRequestDispatcher("/Shg_JSP/ShgActivities.jsp").forward(request, response);

        } else if ("Update".equalsIgnoreCase(ServletName)) {

            try {
              //  BeanUtils.populate(ShgActivitiesBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            try {
                con = DbHandler.getDBConnection();
                try {
                    proc = con.prepareCall("{ call SHG_OPERATIONS.Upsert_shg_activities(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) }");
                } catch (SQLException ex) {
                   // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during processing.");
                }

               proc.setString(1, ShgActivitiesBeanObj.getShgcodeAmend());
                proc.setString(2, ShgActivitiesBeanObj.getPresidentnameAmend());
                proc.setString(3, ShgActivitiesBeanObj.getPresidentoccupationAmend());
                proc.setString(4, ShgActivitiesBeanObj.getPresidentmobileAmend());
                proc.setString(5, ShgActivitiesBeanObj.getSecretarynameAmend());
                proc.setString(6, ShgActivitiesBeanObj.getSecretaryoccupationAmend());
                proc.setString(7, ShgActivitiesBeanObj.getSecretarymobileAmend());
                proc.setString(8, ShgActivitiesBeanObj.getTreasurernameAmend());
                proc.setString(9, ShgActivitiesBeanObj.getTreasureroccupationAmend());
                proc.setString(10, ShgActivitiesBeanObj.getTreasurermobileAmend());
                proc.setString(11, ShgActivitiesBeanObj.getGrpmeetingAmend());
                proc.setString(12, ShgActivitiesBeanObj.getResolutionAmend());
                proc.setString(13, ShgActivitiesBeanObj.getRegisterAmend());
                proc.setString(14, ShgActivitiesBeanObj.getCashAmend());
                proc.setString(15, ShgActivitiesBeanObj.getSavingsAmend());
                proc.setString(16, ShgActivitiesBeanObj.getOtherAmend());
                proc.setString(17, ServletName);

                proc.registerOutParameter(18, java.sql.Types.VARCHAR);
                proc.setString(19, pacsId);

                proc.execute();

               // message = proc.getString(18);

            } catch (SQLException ex) {
               // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    proc.close();
                } catch (SQLException e) {
                    System.out.println("Error occurred during proc close.");
                }
                try {
                    con.close();
                } catch (SQLException ex) {
                   // Logger.getLogger(ShgActivitiesServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during connection close.");
                }

                request.setAttribute("message", message);
                request.getRequestDispatcher("/Shg_JSP/ShgActivities.jsp").forward(request, response);

            }

        }

    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}

